
import java.util.Random;
import java.util.Arrays;

public class SearchDemo
{
	public static void main( String args[] )
	{
		int[] X;
		int[] targets;
		int[] positions1;
		int[] positions2;
		long before;
		long after;
		
		int N = 50000;
		int T = 50000;
		X = randomNumbers( N );
		Arrays.sort( X );
		System.out.println( "N="+N );
		targets = randomNumbers( T );

		System.out.println( "Linear Search ..." );		
		before = System.currentTimeMillis();
		positions1 = RunLinearSearch( X, targets );
		after = System.currentTimeMillis();
		// print( positions1 );
		System.out.printf( "Completed: %d milliseconds\n",(after-before) );

		System.out.println( "Binary Search ..." );		
		before = System.currentTimeMillis();
		positions2 = RunBinarySearch( X, targets );
		after = System.currentTimeMillis();
		// print( positions1 );
		System.out.printf( "Completed: %d milliseconds\n",(after-before) );

	}
	
	public static int[] randomNumbers( int size )
	{
		int[] temp = new int[ size ];
		Random gen = new Random();
		for( int i = 0; i < temp.length; i++ )
		{
			temp[i] = (int) (1000000*gen.nextDouble());
		}
		return temp;
	}
	
	public static void print( int[] A )
	{
		for( int i = 0; i < A.length; i++ )
		{
			System.out.println( i+":"+A[i] );
		}
	}
	
	public static int[] RunLinearSearch( int[] X, int[] targets )
	{
		LinearSearcher searcher = new LinearSearcher( X );
		int[] pos = new int[targets.length];
		for( int i = 0; i < targets.length; i++ )
		{
			pos[i] = searcher.search( targets[i] );
		}
		return pos;
	}

	public static int[] RunBinarySearch( int[] X, int[] targets )
	{
		BinarySearcher searcher = new BinarySearcher( X );
		int[] pos = new int[targets.length];
		for( int i = 0; i < targets.length; i++ )
		{
			pos[i] = searcher.search( targets[i] );
		}
		return pos;
	}
	
}
